import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';



class HomeScreen4test extends StatefulWidget {
  const HomeScreen4test({Key? key}) : super(key: key);

  @override
  State<HomeScreen4test> createState() => _HomeScreen4testState();
}

class _HomeScreen4testState extends State<HomeScreen4test> {

  PageController pageController=PageController(initialPage: 0);
  Timer? timer;
  int _currentIndex=0;
  final ScrollController scrollController = ScrollController();
  List<dynamic> categoryImage = ['bag.jpg', 'camera.jpg', 'beauty.jpg', 'furniture.jpg',
    'headphone.jpg', 'laptop.jpg', 'phone.jpg', 'shoe.jpg', 'toys.jpg', 'tv.jpg',];
  List categoryName=['Bags','Cameras','Beauty','Furniture','Headphone','Laptops','SmartPhone','Shoes','Toys','TV'];
  List productPrice=['234','232','543','132','534','645','2342','234',];
  List productImage=['flash1.jpg','flash2.jpg','flash3.jpg','flash4.jpg','flash5.jpg',
    'flash6.jpg','flash7.jpg','flash8.jpg',];
  List productName=[' Apprenticeship Choice Premium Acoustic Guitar','2.5kg hex dumbbells - 1 pair',
    'Waterproof Backpack American Tourister','USB Charging Men Multifunction PU Chest Bag',
    'High neck sneakers or men with lace up','Premium Quality Print Shirt For Men',
    'Folding Iron Table 14*42 -Multicolor','Stylish Combo SET - T-Shirt And Trouser for Men',];
  List<dynamic> bannerImage = ['1.jpg', '2.jpg', '3.jpg', '4.jpg', '5.jpg'];




  @override
  void initState() {
    super.initState();
    // SystemChrome.setSystemUIOverlayStyle(SystemUiOverlayStyle(statusBarColor: Colors.transparent,statusBarIconBrightness: Brightness.dark,));
    timer=Timer.periodic(const Duration(seconds: 2), (Timer timer) {
      return setState(() {
        pageController.animateToPage(
          _currentIndex+1,
          duration: const Duration(milliseconds: 600),
          curve: Curves.fastEaseInToSlowEaseOut,
        );
        // print('timer currentIndex $_currentIndex');
      });
    });
  }

  @override
  void dispose() {
    scrollController.dispose();
    timer?.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    Size screenSize = MediaQuery.of(context).size;
    const myColor=Colors.cyan;
    return  Scaffold(
      body: CustomScrollView(
        slivers: [
          SliverAppBar(
            systemOverlayStyle: const SystemUiOverlayStyle( statusBarColor: Colors.transparent,statusBarIconBrightness: Brightness.dark ),
            backgroundColor: Colors.white,
            shadowColor: Colors.white,
            expandedHeight: 240,
            toolbarHeight: 50,
            centerTitle: false,
            pinned: true ,
            automaticallyImplyLeading: false ,
            title:  Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                IconButton(onPressed: (){}, icon: Icon(Icons.arrow_back_ios,color: myColor,)),
                Container(
                  width: screenSize.width*.65,
                  height: 40,
                  padding: EdgeInsets.only(top: 4,bottom: 4),
                  decoration: BoxDecoration(borderRadius: BorderRadius.circular(10),
                  border: Border.all(width: 1,color: Colors.grey),
                  color: Colors.white
                  ),
                  child: TextFormField(
                    textInputAction: TextInputAction.search,
                    onFieldSubmitted: (text){
                      // Navigator.pushAndRemoveUntil(context, MaterialPageRoute(builder: (context)=>SearchScreen(search: text)), (route) => true);
                    },
                    decoration: const InputDecoration(
                        contentPadding: EdgeInsets.zero,
                        enabledBorder: OutlineInputBorder(
                            borderSide: BorderSide.none
                        ),
                        focusedBorder: OutlineInputBorder(
                            borderSide: BorderSide.none
                        ),
                        prefixIcon: Icon(Icons.search)
                    ),
                  ),
                ),
                IconButton(onPressed: (){}, icon: Icon(Icons.shopping_cart,color: myColor,)),
              ],
            ),
            flexibleSpace: FlexibleSpaceBar(
              background: Stack(
                 children: [
                   PageView.builder(
                       scrollBehavior: const ScrollBehavior(),
                       controller: pageController,
                       onPageChanged: (index){
                         setState(() {
                           _currentIndex=index ;
                         });
                       },
                       itemBuilder: (BuildContext context, int index){
                         if(bannerImage.isEmpty){
                           return  LinearProgressIndicator(
                             color: Colors.grey.shade100,
                             backgroundColor: Colors.white54,
                           );
                         }else {
                           return
                             Container(
                                 width: screenSize.width,
                                 decoration: BoxDecoration(
                                     color: Colors.blueAccent,
                                     image: DecorationImage(image: AssetImage('assets/ecom/${bannerImage[index % bannerImage.length]}'),fit: BoxFit.cover)
                                 )
                             );
                         }
                       }
                   ),
                   Padding(
                     padding:  EdgeInsets.only(top: screenSize.height*.29),
                     child: Row(
                       mainAxisAlignment: MainAxisAlignment.center,
                       children: [
                         for(var i=0; i<bannerImage.length; i++)
                           Padding(
                             padding: const EdgeInsets.all(8.0),
                             child: AnimatedContainer(
                               duration: Duration(milliseconds: 200),
                               height: i==_currentIndex %bannerImage.length? 10:8,
                               width:  i==_currentIndex %bannerImage.length? 22:8,
                               decoration:   BoxDecoration(
                                   color: i==_currentIndex %bannerImage.length? myColor: Colors.white70,
                                   borderRadius: BorderRadius.circular(10),
                                   boxShadow: const [BoxShadow(
                                     blurRadius: 1,
                                     color: Colors.grey,
                                     spreadRadius: 1,
                                   )
                                   ]
                               ),
                             ),
                           )
                       ],),
                   ),
                 ],
               ),
            ),
          ),
          SliverToBoxAdapter(
            child: Column(
              children: [
                SizedBox(height: 10,),
                Padding(
                  padding: const EdgeInsets.symmetric(horizontal: 15.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      const Text('Category',style: TextStyle(
                          fontSize: 20,
                          fontWeight: FontWeight.bold
                      ),),

                      TextButton(onPressed: (){}, child: Text('See More'),
                        style: TextButton.styleFrom(
                          foregroundColor: Colors.white,
                          backgroundColor: myColor,
                          padding: EdgeInsets.symmetric(horizontal: 20),
                          textStyle: TextStyle(fontSize: 18)
                        ),
                     )
                    ],
                  ),
                ),
                SizedBox(
                    // padding: EdgeInsets.only(top: screenSize.height*.22),
                    height: screenSize.height*.37,
                    child: Container(
                      margin: const EdgeInsets.only(left: 12,right: 12,),
                      child: GridView.builder(
                          scrollDirection: Axis.horizontal,
                          cacheExtent: 20,
                          gridDelegate:const SliverGridDelegateWithFixedCrossAxisCount(
                              childAspectRatio: 1,
                              crossAxisSpacing: 9,
                              mainAxisSpacing: 10,
                              crossAxisCount: 2),
                          physics: const ScrollPhysics(),
                          shrinkWrap: true,
                          itemCount: categoryImage.length??0,
                          itemBuilder: (BuildContext context, int index) {
                            if (categoryImage.isEmpty) {
                              return  Center(
                                child: LinearProgressIndicator(
                                  minHeight: double.infinity,
                                  color: Colors.grey.shade100,
                                  backgroundColor: Colors.white54,
                                ),
                              );
                            } else {
                              return Container(
                                margin: EdgeInsets.only(top: 5,bottom: 5),
                                decoration: BoxDecoration(
                                  color: Colors.white,
                                  borderRadius: BorderRadius.circular(10),
                                  boxShadow: const [BoxShadow(
                                      offset: Offset(0,0),
                                      color: Colors.grey,
                                      blurRadius: 4
                                  )
                                  ],
                                ),
                                child: GestureDetector(
                                  onTap: () {},
                                  child: Column(
                                    mainAxisAlignment: MainAxisAlignment.spaceAround,
                                    children: [
                                      Container(
                                        height: 100,
                                        margin: const EdgeInsets.only(top: 5,bottom: 5),
                                        alignment: Alignment.center,
                                        child: Image(
                                            image: AssetImage('assets/ecom/${categoryImage[index]}'),
                                            // fit: BoxFit.cover,
                                            width:double.infinity
                                        ),
                                      ),
                                      Container(
                                          // margin: const EdgeInsets.only(top: 10),
                                          padding: const EdgeInsets.only( left: 10,right: 10),
                                          alignment: Alignment.center,
                                          child: Text('${categoryName[index]}',maxLines: 2,style: const TextStyle(fontSize: 18),)),


                                    ],
                                  ),
                                ),
                              );
                            }
                          }),
                    )
                ),
                Padding(
                  padding: const EdgeInsets.symmetric(horizontal: 15.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      const Text('Flash Sale',style: TextStyle(
                          fontSize: 20,
                          fontWeight: FontWeight.bold
                      ),),

                      TextButton(onPressed: (){}, child: Text('See More'),
                        style: TextButton.styleFrom(
                            foregroundColor: Colors.white,
                            backgroundColor: myColor,
                            padding: EdgeInsets.symmetric(horizontal: 20),
                            textStyle: TextStyle(fontSize: 18)
                        ),
                      )
                    ],
                  ),
                ),
                Container(
                  height: 350,
                  margin: const EdgeInsets.only(left: 12,right: 12,),
                  child: ListView.builder(
                    scrollDirection: Axis.horizontal,
                      physics: const ScrollPhysics(),
                      shrinkWrap: true,
                      itemCount: productImage.length??0,
                      itemBuilder: (BuildContext context, int index) {
                        if (productImage.isEmpty) {
                          return  Center(
                            child: LinearProgressIndicator(
                              minHeight: double.infinity,
                              color: Colors.grey.shade100,
                              backgroundColor: Colors.white54,
                            ),
                          );
                        } else {

                          return Container(
                            width: 200,
                            height: 300,
                            margin: EdgeInsets.all(5),
                            decoration: BoxDecoration(
                              color: Colors.white,
                              borderRadius: BorderRadius.circular(10),
                              boxShadow: const [BoxShadow(
                                  offset: Offset(1,3),
                                  color: Colors.grey,
                                  blurRadius: 10
                              )
                              ],
                            ),
                            child: GestureDetector(
                              onTap: () {},
                              child: Column(
                                mainAxisAlignment: MainAxisAlignment.spaceAround,
                                children: [
                                  Container(
                                    height: 150,
                                    margin: const EdgeInsets.only(top: 15),
                                    alignment: Alignment.center,
                                    child: Image(
                                        image: AssetImage('assets/ecom/${productImage[index]}'),
                                        // fit: BoxFit.cover,
                                        width:double.infinity
                                    ),
                                  ),
                                  Container(
                                      margin: const EdgeInsets.only(top: 10),
                                      padding: const EdgeInsets.only( left: 10,right: 10),
                                      alignment: Alignment.centerLeft,
                                      child: Text('${productName[index]}',maxLines: 2,style: const TextStyle(fontSize: 18),)),
                                  Container(
                                      margin: const EdgeInsets.only(left: 10,right: 10,top: 10),
                                      alignment: Alignment.centerLeft,
                                      child: Text('\u0024${productPrice[index]}',style: const TextStyle(fontSize: 18),)
                                  ),
                                  Container(
                                    margin: const EdgeInsets.only(top: 10),
                                    padding: const EdgeInsets.symmetric(horizontal: 10),
                                    width: double.maxFinite/2,
                                    child: ElevatedButton(
                                        style: ElevatedButton.styleFrom(backgroundColor: myColor),
                                        onPressed: (){
                                        },
                                        child: const Text('Add to Cart')),
                                  )
                                ],
                              ),
                            ),
                          );
                        }
                      }),
                ),
                SizedBox(height: 10,),
                Padding(
                  padding: const EdgeInsets.symmetric(horizontal: 15.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      const Text('Product For You',style: TextStyle(
                          fontSize: 20,
                          fontWeight: FontWeight.bold
                      ),),

                      TextButton(onPressed: (){}, child: Text('See More'),
                        style: TextButton.styleFrom(
                            foregroundColor: Colors.white,
                            backgroundColor: myColor,
                            padding: EdgeInsets.symmetric(horizontal: 20),
                            textStyle: TextStyle(fontSize: 18)
                        ),
                      )
                    ],
                  ),
                ),

                Container(
                  margin: const EdgeInsets.only(left: 12,right: 12,),
                  child: GridView.builder(
                    padding: EdgeInsets.only(top: 10),
                      cacheExtent: 20,
                      gridDelegate:  const SliverGridDelegateWithFixedCrossAxisCount(
                          childAspectRatio: .6,
                          crossAxisSpacing: 9,
                          mainAxisSpacing: 10,
                          crossAxisCount: 2),
                      physics: const ScrollPhysics(),
                      shrinkWrap: true,
                      itemCount: productImage.length??0,
                      itemBuilder: (BuildContext context, int index) {
                        if (productImage.isEmpty) {
                          return  Center(
                            child: LinearProgressIndicator(
                              minHeight: double.infinity,
                              color: Colors.grey.shade100,
                              backgroundColor: Colors.white54,
                            ),
                          );
                        } else {

                          return Container(
                            decoration: BoxDecoration(
                              color: Colors.white,
                              borderRadius: BorderRadius.circular(10),
                              boxShadow: const [BoxShadow(
                                  offset: Offset(1,3),
                                  color: Colors.grey,
                                  blurRadius: 10
                              )
                              ],
                            ),
                            child: GestureDetector(
                              onTap: () {},
                              child: Column(
                                mainAxisAlignment: MainAxisAlignment.spaceAround,
                                children: [
                                  Container(
                                    height: 150,
                                    margin: const EdgeInsets.only(top: 15),
                                    alignment: Alignment.center,
                                    child: Image(
                                        image: AssetImage('assets/ecom/${productImage[index]}'),
                                        // fit: BoxFit.cover,
                                        width:double.infinity
                                    ),
                                  ),
                                  Container(
                                      margin: const EdgeInsets.only(top: 10),
                                      padding: const EdgeInsets.only( left: 10,right: 10),
                                      alignment: Alignment.centerLeft,
                                      child: Text('${productName[index]}',maxLines: 2,style: const TextStyle(fontSize: 18),)),
                                  Container(
                                      margin: const EdgeInsets.only(left: 10,right: 10,top: 10),
                                      alignment: Alignment.centerLeft,
                                      child: Text('\u0024${productPrice[index]}',style: const TextStyle(fontSize: 18),)
                                  ),
                                  Container(
                                    margin: const EdgeInsets.only(top: 10),
                                    padding: const EdgeInsets.symmetric(horizontal: 10),
                                    width: double.maxFinite/2,
                                    child: ElevatedButton(
                                        style: ElevatedButton.styleFrom(backgroundColor: myColor),
                                        onPressed: (){
                                        },
                                        child: const Text('Add to Cart')),
                                  )
                                ],
                              ),
                            ),
                          );
                        }
                      }),
                ),
              ],
            ),
          )
        ],
      ),

    );
  }


}





